#include <curl/curl.h>

#include "histogram.h"
#include "text.h"
#include "svg.h"
#include <iostream>
#include <vector>
#include <string>

using namespace std;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
};

Input input_data(istream& in, bool promt = false) {

    //-
    Input qin;

    //  
    size_t number_count;
    if( promt ) {
        cerr << "Enter number count: ";
    }
    in >> number_count;

    // 
    qin.numbers.resize(number_count);
    for (size_t i = 0 ; i < number_count ; i++) {
        in >> qin.numbers[i];
    }

    //  
    if( promt ) {
        cerr << "Enter bin count: ";
    }
    in >> qin.bin_count;
    return qin;
}

int main(int argc, char* argv[]) {

    curl_global_init(CURL_GLOBAL_ALL);

    if(argc > 1) {
        CURL *curl = curl_easy_init();
        if(curl) {
            CURLcode res;
            curl_easy_setopt(curl, CURLOPT_URL, argv[1]);
            res = curl_easy_perform(curl);
            curl_easy_cleanup(curl);
        }
        return 0;
    }

    auto in = input_data(cin);
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_svg(bins);
}
